Package: miRNApath
Type: Package
Title: miRNApath: Pathway Enrichment for miRNA Expression Data
Version: 1.72.0
Author: James M. Ward <jmw86069@gmail.com> with contributions
   from Yunling Shi, Cindy Richards, John P. Cogswell
Maintainer: James M. Ward <jmw86069@gmail.com>
Description: This package provides pathway enrichment techniques
   for miRNA expression data. Specifically, the set of
   methods handles the many-to-many relationship between miRNAs
   and the multiple genes they are predicted to target (and thus
   affect.)  It also handles the gene-to-pathway relationships
   separately. Both steps are designed to preserve the additive
   effects of miRNAs on genes, many miRNAs affecting one gene,
   one miRNA affecting multiple genes, or many miRNAs affecting
   many genes.
License: LGPL-2.1
biocViews: Annotation, Pathways, DifferentialExpression,
        NetworkEnrichment, miRNA
Depends: methods, R(>= 2.7.0)
LazyLoad: Yes
git_url: https://git.bioconductor.org/packages/miRNApath
git_branch: RELEASE_3_23
git_last_commit: b18488b
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 23:17:50 UTC; biocbuild

`convertFoldChange` <-
function
( foldchanges, style )
{
   if ( any(foldchanges < 0) )
   {
      if (any(foldchanges < 1 & foldchanges > 0))
      {
         obsstyle = "log directional";
         if (style == "directional")
         {
            foldchanges = 2^foldchanges;
            foldchanges[foldchanges < 1] = -1 / (foldchanges[foldchanges < 1]);
         } else if (style == "fractional")
         {
            foldchanges = 2^foldchanges;
         }
      } else {
         obsstyle = "directional";
         if (style == "log directional")
         {
            foldchanges[foldchanges < 0] = -1 / foldchanges[foldchanges < 0];
            foldchanges = log2(foldchanges);
         } else if (style == "fractional")
         {
            foldchanges[foldchanges < 0] = -1 / foldchanges[foldchanges < 0];
         }
      }
   } else {
      obsstyle = "fractional";
      if (style == "directional")
      {
         foldchanges[foldchanges < 1] = -1 / (foldchanges[foldchanges < 1]);
      } else if (style == "log directional")
      {
         foldchanges = log2(foldchanges);
      }
   }
   return(foldchanges);
}

setClass("mirnapath", 
   representation(
      mirnaTable="data.frame", 
      columns="character", 
      groupcount="numeric", 
      state="character", 
      mirnaGene="data.frame", 
      mirnaPathways="data.frame", 
      pathwaycount="numeric", 
      filters="numeric", 
      enrichment="list", 
      pathwayList="character"),
   prototype(
      mirnaTable=data.frame(),
      columns=character(0), 
      groupcount=numeric(0), 
      state=character(0), 
      mirnaGene=data.frame(), 
      mirnaPathways=data.frame(), 
      pathwaycount=numeric(0), 
      filters=numeric(0), 
      enrichment=list(), 
      pathwayList=character(0)),
   sealed=TRUE,
   package="miRNApath" )

`loadmirnapath` <-
function
( mirnafile = "mirna_input.txt",
  mirnacol = "miRNA Name",
  assayidcol = "ASSAYID",
  groupcol = "GROUP",
  filterflagcol = "FILTERFLAG",
  expressioncol = NA,
  foldchangecol = NA,
  pvaluecol = NA)
{
   mirnaTable <- read.table(mirnafile, header=TRUE, sep="\t", fill=FALSE, comment.char = "", check.names = FALSE, quote="\"");
   # Check columns, that they exist as specified
   checkColumns(data = mirnaTable, mandatory = c( mirnacol, groupcol ), numeric = NA );
   columns = c( "mirnacol" = mirnacol, "assayidcol" = assayidcol, "groupcol" = groupcol, "filterflagcol" = filterflagcol );
   if (!is.na(groupcol))
   {
      # Count the number of groups in the dataset
      groupcount = length(levels(as.factor(mirnaTable[,groupcol])));
   } else {
      groupcount = 0;
   }

   # check whether the data is already prepared for enrichment with hits and full library
   if ( any( colnames(mirnaTable) %in% filterflagcol ) )
   {
      state = "filtered";
   } else {
      state = "unfiltered";
   }

   #mirnaobj <- list(mirnaTable = mirnaTable, columns = columns, groupcount = groupcount, state = state );
   mirnaobj <- new("mirnapath", mirnaTable = mirnaTable, columns = columns, groupcount = groupcount, state = state );
   #class(mirnaobj) = "mirnapath";
   return(mirnaobj);
}

`runEnrichment` <-
function
( mirnaobj,
  Composite = TRUE,
  groups = NULL,
  permutations = 0)
{
	# The Composite argument tells whether the assayid and gene id should be concatenated
	# in order to preserve the original library size faithfully

   # The groups argument specifies which subsets of groups to analyze, sending NA will
   # run all groups in the mirnaobj@mirnaTable

   mirnacol <- mirnaobj@columns["mirnacol"];
   genecol <- mirnaobj@columns["genecol"];
   mirnagene <- mirnaobj@columns["mirnagene"];
   groupcol <- mirnaobj@columns["groupcol"];
   pathwaycol <- mirnaobj@columns["pathwaycol"];
   pathwayidcol <- mirnaobj@columns["pathwayidcol"];
   filterflagcol <- mirnaobj@columns["filterflagcol"];
   if ( is.na(mirnacol) ) {
      stop("mirnaobj@columns has no value for mirnacol");
   }
   if ( is.na(genecol) ) {
      stop("mirnaobj@columns has no value for genecol");
   }
   if ( is.na(mirnagene) ) {
      stop("mirnaobj@columns has no value for mirnagene");
   }
   if ( is.na(groupcol) ) {
      stop("mirnaobj@columns has no value for groupcol");
   }
   if ( is.na(pathwaycol) ) {
      stop("mirnaobj@columns has no value for pathwaycol");
   }
   if ( is.na(pathwayidcol) ) {
      stop("mirnaobj@columns has no value for pathwayidcol");
   }
   if ( is.na(filterflagcol) ) {
      stop("mirnaobj@columns has no value for filterflagcol");
   }

   if ( is.null(groups) )
   {
      groups <- levels(as.factor(mirnaobj@mirnaTable[, mirnaobj@columns["groupcol"] ]));
   }

   groupResults <- lapply( groups, function(group)
   {
      # iterate through each group as supplied
      groupData <- mirnaobj@mirnaTable[ mirnaobj@mirnaTable[,groupcol] %in% group , ];
      
      groupmirnas <- unique(as.character(groupData[,mirnacol]));
      groupmirnas <- groupmirnas[ !groupmirnas %in% "" ];
      groupmirnaGene <- as.matrix(mirnaobj@mirnaGene[mirnaobj@mirnaGene[,mirnacol] %in% groupmirnas,]);
      groupgenes <- unique(as.character(groupmirnaGene[,genecol]));
      groupPathways <- as.matrix(mirnaobj@mirnaPathways[ mirnaobj@mirnaPathways[,genecol] %in% groupgenes ,]);
      # Repair the pathwayidcol numerical values
      groupPathways[,pathwayidcol] = gsub("^[ ]+", "", groupPathways[,pathwayidcol]);

      permresults <- lapply( 0:permutations, function(perm)
      {
         if (perm == 0)
         {
            # This iteration is non-random, not part of permutation correction
            # filteredmirnas contains the list of actual miRNA hits,
            # upon which everything else is based.
            filteredmirnas <- unique( as.character( groupData[ groupData[, filterflagcol] == 1, mirnacol] ) );
            filteredmirnas <- filteredmirnas[ !filteredmirnas %in% "" ];
         } else {
            # Randomize the miRNA hits, using the same number of miRNA hits
            # Randomizing the miRNA hits and replacing them in filteredmirnas
            # should provide a reasonable permutation model.
            filteredmirnas <- unique( as.character( groupData[ groupData[, filterflagcol] == 1, mirnacol] ) );
            filteredmirnas <- filteredmirnas[ !filteredmirnas %in% "" ];
            filteredmirnas <- sample(groupmirnas, length(filteredmirnas));
         }
         filteredmirnaGene <- mirnaobj@mirnaGene[mirnaobj@mirnaGene[,mirnacol] %in% filteredmirnas,];

         # Test for, and remove, any groups with only one element
         # (otherwise "second argument must be a list" error)
         # singletGroups = tapply(groupPathways[,genecol], groupPathways[, pathwayidcol], length) == 1;
         
         # Generate a table storing mirna, gene, and mirnagene information for each Pathway ID
         pathsizes <- do.call(rbind, tapply( as.character(groupPathways[, genecol]) , groupPathways[, pathwayidcol], function(pathGenes)
         {
            # Make sure the pathway has one gene only once each
            pathGenes = unique(pathGenes);
            
            # If the following has 'unique' it collapses miRNA having multiple binding sites on the same gene to 1 entry
            univmirnaGene <- groupmirnaGene[groupmirnaGene[, genecol] %in% pathGenes,];
            if (length(univmirnaGene) > dim(groupmirnaGene)[2])
            {
               univmirnaGene <- matrix(ncol=dim(groupmirnaGene)[2], univmirnaGene);
            } else {
               univmirnaGene <- matrix(ncol=dim(groupmirnaGene)[2], byrow=TRUE,
                  univmirnaGene);
            }
            colnames(univmirnaGene) <- colnames(groupmirnaGene);
            univmirnagenecount <- dim(univmirnaGene)[1];

            enrichmirnaGene <- univmirnaGene[univmirnaGene[, mirnacol] %in% filteredmirnas,];
            if (length(enrichmirnaGene) > dim(groupmirnaGene)[2])
            {
               enrichmirnaGene <- matrix(ncol=dim(groupmirnaGene)[2], enrichmirnaGene);
            } else {
               enrichmirnaGene <- matrix(ncol=dim(groupmirnaGene)[2], byrow=TRUE,
                  enrichmirnaGene);
            }
            enrichedmirnagenecount <- dim(enrichmirnaGene)[1];
            numenrichmirna = 0;
            numenrichgenes = 0;
            if (enrichedmirnagenecount > 0)
            {
               colnames(enrichmirnaGene) <- colnames(univmirnaGene);
               rownames(enrichmirnaGene) <- 1:dim(enrichmirnaGene)[1];
               numenrichmirna = length(unique(enrichmirnaGene[, mirnacol]));
               numenrichgenes = length(unique(enrichmirnaGene[, genecol]));
            }

            r1 <- list("Pathway miRNA-Gene Count"=univmirnagenecount, "Enriched miRNA-Gene Count"=enrichedmirnagenecount,
               "Enriched miRNA-Genes"=enrichmirnaGene, "Genes Enriched"=numenrichgenes,
               "miRNAs Enriched"=numenrichmirna);
            return(r1);
         } ) )
         # End pathsizes tapply

         # For simplicity, remove pathways with no significant mirnaGenes
         pathsizes = pathsizes[sapply(pathsizes[,"Enriched miRNA-Gene Count"], function(i){i[[1]] > 0;}), ];

         # Target P-value command
         nFilteredmirnaGene = dim(filteredmirnaGene)[1]; # total number of target mirna-genes represented by the filtered miRNAs
         nmirnaGene = dim(groupmirnaGene)[1]; # total number of mirna-genes tested (filtered plus unfiltered miRNAs)
         useCts = do.call(c, pathsizes[, "Enriched miRNA-Gene Count"]); # total enriched mirnaGenes for each pathway
         gCounts = do.call(c, pathsizes[, "Pathway miRNA-Gene Count"]); # total mirna-genes in each pathway's universe
         pvs <- phyper(useCts - 1, nFilteredmirnaGene, nmirnaGene - nFilteredmirnaGene, gCounts, lower.tail = FALSE)
         names(pvs) = rownames(pathsizes);

         ord <- order(pvs)

         if (perm == 0)
         {
            r1 = list(pvalues = pvs[ord], "Measured pathway mirnaGenes" = gCounts[ord], 
               "Enriched pathway mirnaGenes" = useCts[ord], "Total mirnaGenes" = nmirnaGene, 
               "Total filtered mirnaGenes" = nFilteredmirnaGene,
               "Enriched miRNA-Genes" = pathsizes[ord, "Enriched miRNA-Genes"],
               "Genes Enriched"=sapply(pathsizes[ord, "Genes Enriched"],c),
               "miRNAs Enriched"=sapply(pathsizes[ord, "miRNAs Enriched"],c));
            r1;
         } else {
            r1 = list(pvalues = pvs);
            r1;
         }
      } )
      # End permresults lapply

      # Determine permutation P-value (if exists)
      if (permutations > 0)
      {
         # April 2009: Fix bug when permutations do not supply results for
         # all pathwayIDs, and cannot be directly rbind'ed into a data.frame
         permIDs = sort(unique(do.call(c, lapply(1:length(permresults), function(j)
                     {
                        names(permresults[[j]]$pvalues);
                     })) ));
         permtable = do.call(rbind, lapply(1:length(permresults), function(j)
               {
                  pTemp = permresults[[j]]$pvalues[permIDs];
                  names(pTemp) = permIDs;
                  pTemp[is.na(pTemp)] = 1;
                  pTemp;
               } ) );
         permps = apply(permtable, 2, function(i)
            {
               (rank(i)[1]/length(i));
            } )
         permresults[[1]]$permpvalues = permps;
      }
      permresults[[1]];
   } ); # End lapply(groups...)
   names(groupResults) = groups;

   mirnaobj@enrichment = groupResults;
   mirnaobj@state = "enriched";

   # Double-check that the pathwayList is present, just in case
   if (!"pathwayList" %in% slotNames(mirnaobj) | length(mirnaobj@pathwayList) == 0 )
   {
      pathwayTable = unique(mirnaobj@mirnaPathways[,c(pathwayidcol, pathwaycol)]);
      pathwayList = pathwayTable[,pathwaycol];
      names(pathwayList) = pathwayTable[,pathwayidcol];
      mirnaobj@pathwayList = pathwayList;
   }

   return(mirnaobj);
}

`checkColumns` <-
function
( data,
  mandatory = NA,
  numeric = NA )
{
   if ( all(!is.na(mandatory)) & length(mandatory) > 0 )
   {
      mand = sapply( mandatory, function(i)
      {
         if ( any(colnames(data) %in% i) )
         {
            T;
         } else {
            F;
         }
      } )
   } else { mand = NA }
   if ( all(!is.na(numeric)) & length(numeric) > 0 )
   {
      nume = sapply( numeric, function(i)
      {
         if ( any(colnames(data) %in% i) & all(is.numeric(data[,i])) )
         {
            T;
         } else {
            F;
         }
      } )
   } else { nume = NA }
   msg = NA;
   if ( length(mand[!mand]) > 0 & all(!is.na(mand)) )
   {
      msg = paste( c("The following mandatory columns are not found in the data:", paste(c(names(mand)[!mand]), collapse=", ")), collapse=" ");
   }
   if ( length(nume[!nume]) > 0 & all(!is.na(nume)) )
   {
      msg2 = paste( c("The following columns are required to be numeric:", paste(c(names(nume)[!nume]), collapse=", ")), collapse=" ") 
      if ( is.na(msg) )
      {
         msg = msg2;
      } else {
         msg = paste( c(msg, msg2), collapse="\n" );
      }
   }
   if ( !is.na(msg) )
   {
      stop(msg);
   }
}

`filtermirnapath` <-
function
( mirnaobj,
  pvalue = NA,
  expression = NA,
  foldchange = NA )
{
   filterflagvals = rep(2, dim(mirnaobj@mirnaTable)[1] );
   if ( length( mirnaobj@columns[names(mirnaobj@columns) %in% "filterflagcol"] ) > 0 )
   {
      filterflagcol = mirnaobj@columns["filterflagcol"];
   } else {
      filterflagcol = "FILTERFLAG";
      mirnaobj@columns = c(mirnaobj@columns, "filterflagcol" = filterflagcol);
   }
   if ( class(mirnaobj) != "mirnapath" )
   {
      stop("The mirnaobj object is not the proper class of mirnapath.");
   }
   filters = c();
   if ( !is.na(pvalue) )
   {
      if ( length( mirnaobj@columns[names(mirnaobj@columns) %in% "pvaluecol"] ) > 0)
      {
         pvaluecol = mirnaobj@columns[names(mirnaobj@columns) %in% "pvaluecol"];
         filterflagvals[mirnaobj@mirnaTable[,pvaluecol] <= pvalue & filterflagvals != 0 & !is.na(mirnaobj@mirnaTable[,pvaluecol]) ] = 1;
         filters = c(filters, "P-value" = pvalue);
      } else {
         stop("A P-value filtering value was supplied, but no pvaluecol exists in mirnaobj.");
      }
   }
   if ( !is.na(expression) )
   {
      if ( length( mirnaobj@columns[names(mirnaobj@columns) %in% "expressioncol"] ) > 0)
      {
         expressioncol = mirnaobj@columns[names(mirnaobj@columns) %in% "expressioncol"];
         filterflagvals[ (mirnaobj@mirnaTable[,expressioncol] >= expression | !is.na(mirnaobj@mirnaTable[,expressioncol]) ) & filterflagvals != 0 ] = 1;
         filters = c(filters, "Expression" = expression);
      } else {
         stop("An expression filtering value was supplied, but no expressioncol exists in mirnaobj.");
      }
   }
   if ( !is.na(foldchange) )
   {
      if ( length( mirnaobj@columns[names(mirnaobj@columns) %in% "foldchangecol"] ) > 0)
      {
         foldchangecol = mirnaobj@columns[names(mirnaobj@columns) %in% "foldchangecol"];
         # Convert fold change style into "directional fold change" (not fraction)
         foldchanges = convertFoldChange( mirnaobj@mirnaTable[,foldchangecol], style = "directional");
         filterflagvals[foldchanges >= expression & filterflagvals != 0 & !is.na(foldchanges) ] = 1;
         filters = c(filters, "Fold change" = foldchange);
      } else {
         stop("An expression filtering value was supplied, but no expressioncol exists in mirnaobj.");
      }
   }
   if (length(filters) == 0)
   {
      print("No filters were applied.");
      mirnaobj@status = "unfiltered";
   } else {
      mirnaobj@mirnaTable[,filterflagcol] = filterflagvals;
      mirnaobj@filters = filters;
      mirnaobj@state = "filtered";
   }
   return(mirnaobj);
}

`mirnaTable` <-
function
( mirnaobj, groups = NULL,
  format = "Tall",
  Significance = 0.2,
  na.char = NA,
  pvalueTypes = c("pvalues", "permpvalues"),
  maxStringLength = NA
 )
{
   # some column headers
   pathwaycol = mirnaobj@columns["pathwaycol"];
   pathwayidcol = mirnaobj@columns["pathwayidcol"];

   # Make sure pvalueTypes are present in the data
   pvalueTypes <- pvalueTypes[pvalueTypes %in% names(mirnaobj@enrichment[[1]]) ];
   if (length(pvalueTypes) == 0)
   {
      stop("The pvalueTypes argument does not match the enrichment\nP-value columns.");
   }

   # Determine which groups to return
   if (is.null(groups))
   {
      groups = names(mirnaobj@enrichment);
   } else {
      groups = groups[groups %in% names(mirnaobj@enrichment)];
   }

   # Return a data.frame with the relevant information
   fulltable <- do.call(rbind, lapply(as.character(groups), function(group)
   {
      t1 <- data.frame( check.names = FALSE, mirnaobj@enrichment[[group]]
         [c(pvalueTypes, "Measured pathway mirnaGenes", 
         "Enriched pathway mirnaGenes", "Genes Enriched", 
         "miRNAs Enriched", "Total mirnaGenes", "Total filtered mirnaGenes")],
         "Group" = rep(group, length(mirnaobj@enrichment[[group]][[1]]) ) );
      # removed "Enriched by miRNA", "Enriched by Gene" for space considerations

      # Filter by P-value
      pvaltest <- t1[,pvalueTypes] < Significance;
      # If more than one P-value column, let any of them meet the criteria
      if (length(pvalueTypes) > 1)
      {
         pvaltest <- apply(pvaltest, 1, function(i){ any(i) } );
      }
      t1 <- t1[pvaltest,];
      # Add some counts for miRNA-gene hits, instead of very long text strings
#      enrichMiRNACount = sapply(t1[,"Enriched by miRNA"],
#         function(i){nchar(gsub("[^;]", "", i))+1});
#      enrichGeneCount = sapply(t1[,"Enriched by Gene"],
#         function(i){nchar(gsub("[^;]", "", i))+1});
#      enrichEntityCount = sapply(t1[,"Enriched by Gene"],
#         function(i){nchar(gsub("[^;,]", "", i))+1});
#      t1[,"# miRNA enriched"] = enrichMiRNACount;
#      t1[,"# Genes enriched"] = enrichGeneCount;
#      t1[,"# miRNA-Genes enriched"] = enrichEntityCount;
      t1 <- data.frame( check.names=FALSE, t1, pathwayidcol = rownames(t1), "Pathway Name"=mirnaobj@pathwayList[rownames(t1)] );
      colnames(t1)[colnames(t1) == "pathwayidcol"] = pathwayidcol;
      t1[,pathwayidcol] = as.character(t1[,pathwayidcol]);
      t1;
   } ) ) ;
   if (!is.na(maxStringLength))
   {
      fulltable[,!colnames(fulltable) %in% pathwayidcol] = 
      apply(fulltable[,!colnames(fulltable) %in% pathwayidcol], 2, function(i)
      {
         if (all(is.character(i)))
         {
            j = sapply(i, function(k)
            {
               k = substr(k, 1, min(nchar(k), maxStringLength));
            } )
         }
      } )
   }
   if (format == "Tall")
   {
      fulltable;
   } else if (format == "SuperTall")
   {
      # Create a format with mirnaGene values fully expanded
      # useful for bar chart histogram views and for drill-down
      SuperTall <- do.call(rbind, apply(fulltable, 1, function(i)
      {
         pathwayid <- i[pathwayidcol][[1]];
         group <- i["Group"][[1]];
         GMtable <- mirnaobj@enrichment[[group]]["Enriched miRNA-Genes"][[1]][pathwayid][[1]];
         SuperTall1 <- data.frame(check.names=FALSE, do.call(rbind,
               lapply(1:dim(GMtable)[1], function(k2) i) ),
               GMtable);
         SuperTall1;
      } ) )
      SuperTall;
   } else if (format == "Wide")
   {
      widetable <- reshape (fulltable, direction="wide", idvar=pathwayidcol,
            timevar="Group", drop=colnames(fulltable)[!colnames(fulltable) %in% 
            c(pathwayidcol, "Group", pvalueTypes)] );
      # Replace NA with another character if supplied
      if (!is.na(na.char))
      {
         widetable[is.na(widetable)] <- na.char;
      }
      # Add in pathway names using the pathway IDs
      widetable[,pathwaycol] <- mirnaobj@pathwayList[widetable[,1]];
      # Then put the pathway IDs and names first in the table
      widetable <- widetable[,c(pathwayidcol, pathwaycol, colnames(widetable)
         [!colnames(widetable) %in% c(pathwayidcol, pathwaycol)] )];
      widetable;
   }
}

setMethod("show", signature(object="mirnapath"),
definition <- function(object)
{
   cat("mirnapath object:\n");
   y = summary(object);
   print(y);
   cat(paste( c("\nColumns specified:", sapply(names(object@columns), function(i){ paste( c(i, " = \"", object@columns[i], "\""), collapse="" )}), "\n"), collapse="\n   "));
   if ("filters" %in% names(object))
   {
      cat(paste( c("Filters Applied:", sapply(names(object@filters), function(i){ paste( c(i, " = \"", object@filters[i], "\""), collapse="" )}), "\n"), collapse="\n   "));
   } else {
      cat("Filters Applied:\n   none\n\n");
   }
   # number of miRNA's
   mirnacount = length(unique(object@mirnaTable[, object@columns["mirnacol"] ]));
   cat("Number of miRNAs:", mirnacount, "\n");

   # number of individual miRNA-gene predictions
   if ("mirnaGene" %in% names(object))
   {
      mirnagenecount = length(levels(as.factor(object@mirnaGene[, object@columns["mirnagene"] ])));
      cat("Number of individual miRNA-gene predictions:", mirnagenecount, "\n");

      # number of genes represented
      genecount = length(levels(as.factor(object@mirnaGene[, object@columns["genecol"] ])));
      cat("Total number of genes represented:", genecount, "\n");
   }

   cat("Number of sample groups:", object@groupcount, "\n");
   cat("Number of pathways:", ifelse(is.null(object@pathwaycount), 0, object@pathwaycount), "\n");
   cat("State:", object@state, "\n");
}
);

`loadmirnapathways` <-
function
( mirnaobj,
  pathwayfile,
  genecol = "Entrez Gene ID",
  pathwaycol = "PATHWAY",
  columns = c(),
  pathwayidcol = NA)
{
   mirnaPathways <- read.table(pathwayfile, header=TRUE, sep="\t", fill=FALSE, comment.char = "", check.names = FALSE, quote="\""); #\"
   checkColumns( data = mirnaPathways, mandatory = c(pathwaycol, genecol) );

   mirnaGene <- mirnaobj@mirnaGene;

   if (is.na(pathwayidcol))
   {
      pathwayids = as.numeric(as.factor(mirnaPathways[,pathwaycol]));
      pathwayidcol = "PATHWAY_ID";
      mirnaPathways[,pathwayidcol] = pathwayids;
   }

   columns = c( columns, genecol = genecol );
   columns = columns[!is.na(columns)];
   for ( column in names(columns) )
   {
      if ( length(mirnaobj@columns[names(mirnaobj@columns) %in% column]) == 0 )
      {
         stop( paste( c("The following column specified in the loadmirnatogene method is not present in mirnaobj:", column, "\n"), collapse="\n") );
      }
      if ( length(colnames(mirnaGene)[colnames(mirnaGene) %in% mirnaobj@columns[column] ]) == 0 )
      {
         stop( paste( c("The following column specified in the loadmirnatogene method is not present in mirnaGene:", column, "\n"), collapse="\n") );
      }
      tempcol = mirnaobj@columns[column];
      colnames(mirnaPathways)[colnames(mirnaPathways) %in% columns[column]] = tempcol;
   }
   mirnaobj@columns["pathwaycol"] = pathwaycol;
   mirnaobj@columns["pathwayidcol"] = pathwayidcol;
   mirnaobj@mirnaPathways = mirnaPathways;
   pathwayTable = unique(mirnaPathways[,c(pathwayidcol, pathwaycol)]);
   pathwayList = pathwayTable[,pathwaycol];
   names(pathwayList) = pathwayTable[,pathwayidcol];
   mirnaobj@pathwayList = as.character(pathwayList);
   pathwaycount = length(levels(as.factor(mirnaPathways[,pathwaycol])));
   mirnaobj@pathwaycount = pathwaycount;
   return(mirnaobj);
}

`loadmirnatogene` <-
function
( mirnafile,
  mirnaobj,
  mirnacol = "miRNA Name",
  genecol = "Entrez Gene ID",
  columns = NA )
{
   mirnaGene <- read.table(mirnafile, header=TRUE, sep="\t", fill=FALSE, comment.char = "", check.names = FALSE, quote="\"");
   checkColumns( data = mirnaGene, mandatory = c(mirnacol, genecol) );

   columns = c( columns, mirnacol = mirnacol );
   columns = columns[!is.na(columns)];
   for ( column in names(columns) )
   {
      if ( length(mirnaobj@columns[names(mirnaobj@columns) %in% column]) == 0 )
      {
         stop( paste( c("The following column specified in the loadmirnatogene method is not present in mirnaobj:", column, "\n"), collapse="\n") );
      }
      if ( length(colnames(mirnaGene)[colnames(mirnaGene) %in% mirnaobj@columns[column] ]) == 0 )
      {
         stop( paste( c("The following column specified in the loadmirnatogene method is not present in mirnaGene:", column, "\n"), collapse="\n") );
      }
      tempcol = mirnaobj@columns[column];
      colnames(mirnaGene)[colnames(mirnaGene) %in% columns[column]] = tempcol;
   }
   mirnacol = mirnaobj@columns["mirnacol"];
   #CompositeLabel = apply(mirnaobj@mirnaGene[, c(mirnacol, genecol)], 1, function(i)
   CompositeLabel = apply(mirnaGene[, c(mirnacol, genecol)], 1, function(i)
   {
      paste( c(i[1], " (", i[2], ")"), collapse="" );
   });
   mirnaGene[,"miRNA-Gene"] = CompositeLabel;
   mirnaobj@columns["mirnagene"] = "miRNA-Gene";
   mirnaobj@columns["genecol"] = genecol;
   mirnaobj@mirnaGene = mirnaGene;
   return(mirnaobj);
}

\name{mirnaTable}
\alias{mirnaTable}
\title{ Create miRNA Enrichment Summary Table as data.frame }
\description{
  This function takes an miRNApath object which has been
  evaluated by runEnrichment(), and provides a data.frame
  summary.
}
\usage{
mirnaTable(mirnaobj, groups=NULL, format="Tall", 
   Significance=0.2, na.char=NA, pvalueTypes=c("pvalues",
   "permpvalues"), maxStringLength=NA)
}
\arguments{
 \item{mirnaobj}{
     An object of type mirnapath containing data resulting from
     the \code{loadmirnapath} method.
 }
 \item{groups}{
     List of groups to include in the data.frame, or NULL to
     include all groups in the miRNApath object.
 }
 \item{format}{
     This parameter tells the method to return "Tall",
     "SuperTall", or "Wide" data. See details below for a
     description of each format.
 }
 \item{Significance}{
     A numerical value specifying the P-value cutoff to use to
     subset the data returned in the data.frame. To avoid
     subsetting the data, provide a value of 1.
 }
 \item{na.char}{
     Value to use for NA instead of leaving NA as-is, potentially
     useful for text output.
 }
 \item{pvalueTypes}{
     Defines which P-value columns should be returned, more
     useful for the Wide format which could otherwise have two
     sets of P-value columns if permutation adjustment were
     used.
 }
 \item{maxStringLength}{
     Defines the maximum length per character string, after
     being determined by \code{nchar}. Strings and
     column headers are both truncated to this length.
 }
}
\details{
  This function simply combines the various results from the
  runEnrichment method into one data.frame suitable for plotting
  or printing in a table. Due to potentially large data volume,
  the subset feature even when used liberally can substantially
  reduce the returned dataset size.

  The \code{maxStringLength} value is particularly useful, often
  critical, for displaying a summary table in text format, since
  pathway names sample group names can be quite long.
  Although there is no default, a recommended value of 50 seems
  to fit the appropriate balance of being short enough to fit
  within a table, and yet be long enough to describe the
  pathway. The Wide format will contain sample group names as
  column headers, and a value of 50 should not in theory affect
  the name, except where it wouldn't be readable in a table
  anyway.
}
\value{
  data.frame

  For Tall data, the columns contain P-values and other values
  useful for discriminating potential hits, the rows contain each
  miRNA-group combination tested which meets the P-value cutoff.
  The miRNAs and genes contributing to the enrichment results
  are concatenated to be summarized in one row and can be rather
  large.

  For SuperTall data, the Tall table as described above is
  returned, except that the concatenated miRNA-gene values are
  separated to one row each. Every individual miRNA and gene
  value is represented on its own row, which can facilitate some
  summary views or data filtering techniques (e.g. Excel or
  Spotfire.)

  For Wide data, the columns contain the group names, the rows
  contain the pathway name, and the cells contain the P-value.
  Note that the column names will have the P-value column header
  prepended to the column name, e.g. "pvalue.GroupName".

  An important note when supplying string na.char values, be
  sure to convert the data to a numeric matrix before calling
  functions such as heatmap, taking care to remove
  string values or convert strings to 1.0 beforehand.
}
\references{
    John Cogswell (2008) Identification of miRNA changes
    in Alzheimer's disease brain and CSF yields putative 
    biomarkers and insights into disease pathways, Journal of
    Alzheimer's Disease 14, 27-41.
}
\author{ James M. Ward \email{jmw86069@gmail.com} }
\seealso{
    \code{\link{loadmirnapath}},
    \code{\link{filtermirnapath}},
    \code{\link{loadmirnatogene}},
    \code{\link{loadmirnapathways}},
    \code{\link{runEnrichment}},
}
\examples{
## Start with miRNA data from this package
data(mirnaobj);

## Now run enrichment test
mirnaobj <- runEnrichment( mirnaobj=mirnaobj, Composite=TRUE,
   groups=NULL, permutations=0 );

## Print out a summary table of significant results
finaltable <- mirnaTable( mirnaobj, groups=NULL, format="Tall", 
    Significance=0.1, pvalueTypes=c("pvalues") );
finaltable[1:20,];

## Example which calls heatmap function on the resulting data
widetable <- mirnaTable( mirnaobj, groups=NULL, format="Wide", 
    Significance=0.1, na.char=NA, pvalueTypes=c("pvalues") );
## Assign 1 to NA values, assuming they're all equally
## non-significant
widetable[is.na(widetable)] <- 1;

## Display a heatmap of the result across sample groups
pathwaycol <- mirnaobj@columns["pathwaycol"];
pathwayidcol <- mirnaobj@columns["pathwayidcol"];
rownames(widetable) <- apply(widetable[,c(pathwaycol,
   pathwayidcol)], 1, function(i)paste(i, collapse="-"));
wt <- as.matrix(widetable[3:dim(widetable)[2]], mode="numeric")
heatmap(wt, scale="col");

## Show results where pathways are shared in four or more
## sample groups
pathwaySubset <- apply(wt, 1, function(i)
{
   length(i[i < 1]) >= 4;
} )
heatmap(wt[pathwaySubset,], scale="row");
}

\keyword{ manip }

\name{loadmirnatogene}
\alias{loadmirnatogene}
\title{Load miRNA to gene associations for miRNApath}
\description{
This method loads associations between miRNAs to the genes they
affect.
}
\usage{
loadmirnatogene(mirnafile, mirnaobj, mirnacol="miRNA Name",
genecol="Entrez Gene ID", columns=NA)
}
\arguments{
 \item{mirnafile}{
     The tab-delimited miRNA results file to be loaded. The file
     is expected to be in tall-skinny format.
 }
 \item{mirnaobj}{
     An object of type mirnapath containing data resulting from
     the \code{loadmirnapath} method.
 }
 \item{mirnacol}{
     The name of the column header which contains the miRNA names
     being assayed. That is, the name of the column header in the
     file being read.
 }
 \item{genecol}{
     The name of the column header which contains the gene names
     being assayed.
 }
 \item{columns}{
     The names of any additional columns in the file being read
     which should equate with the mirnapath object.
 }
}
\details{
  The data is expected to have miRNA names which exactly match
  those in the mirnaTable item of the mirnapath object. Also, the
  gene names are expected to match exactly with those gene names
  loaded by \code{loadmirnapathways}.
}
\value{
The method returns an object of type mirnapath, a list with
components:

  \item{mirnaTable}{
      data.frame containing the miRNA results data
  }
  \item{columns}{
      list containing the names of required column headers
      associated to the actual column header supplied in the
      dataset contained in mirnaTable. Required headers:
      mirnacol, assayidcol. Optional headers: groupcol,
      pvaluecol, foldchangecol, expressioncol,
      filterflagcol
  }
  \item{groupcount}{
      the number of groups contained in mirnaTable using the
      groupcol, if supplied
  }
  \item{state}{
      the current state of the object, using the following
      values in order of progress through the typical workflow:
      unfiltered, filtered, enriched.
  }
}
\references{
    John Cogswell (2008) Identification of miRNA changes
    in Alzheimer's disease brain and CSF yields putative 
    biomarkers and insights into disease pathways, Journal of
    Alzheimer's Disease 14, 27-41.
}

\author{James M. Ward \email{jmw86069@gmail.com}}

\seealso{
    \code{\link{loadmirnapath}}
    \code{\link{filtermirnapath}}
    \code{\link{loadmirnatogene}}
    \code{\link{loadmirnapathways}}
}
\examples{

## Load miRNA expression data from AD miRNA paper
## This data contains miRNA expression data, 
data(mirnaobj);

## Display the state, which should generally be "unfiltered"
## at this point
mirnaobj@state;

## Display summary information about the object
mirnaobj;

## Annotate hits by filtering by P-value 0.05
mirnaobj <- filtermirnapath( mirnaobj, pvalue = 0.05,
    expression = NA, foldchange = NA );

## Write a file as example of required input
write.table(mirnaobj@mirnaGene, file = "mirnaGene.txt", 
    quote = FALSE, row.names = FALSE, col.names = TRUE, na = "",
    sep = "\t");

## Load the miRNA to gene associations
mirnaobj <- loadmirnatogene( mirnafile = "mirnaGene.txt",
    mirnaobj = mirnaobj, mirnacol = "miRNA Name",
    genecol = "Entrez Gene ID", 
    columns = c(assayidcol = "ASSAYID") );

## Display summary, noting the number of genes reported
mirnaobj;
}

\keyword{ IO }
\keyword{ manip }
\keyword{ attribute }

\name{convertFoldChange}
\alias{convertFoldChange}
\title{ Converts Fold Change to Consistent Format }
\description{
  The script tries to determine if the fold changes
  are in an expected format, and if not, does its best
  to convert correctly. Internal function.
}
\usage{
convertFoldChange(foldchanges, style)
}
\arguments{
  \item{foldchanges}{ numerical values with fold changes }
  \item{style}{ type of fold change to return. }
}
\details{
  Allowed formats are:
  "log directional" (contains continuous numbers positive and
  negative, including numbers between -1 and 1),
  "directional", includes positive and negative values, but no
  numbers between -1 and 1, and
  "fractional", includes values greater than zero, especially
  those less than one.
}
\value{
  numerical values in the defined format
}
\author{ James M. Ward \email{jmw86069@gmail.com} }
\examples{
## No examples currently.
}

\keyword{ manip }
\keyword{ internal }

\name{loadmirnapath}
\alias{loadmirnapath}
\title{Load miRNApath Data}
\description{
    This method loads data from a tab-delimited flatfile into an
    object of type mirnapath to be used for further miRNA
    analysis.
}
\usage{
loadmirnapath(mirnafile="mirna_input.txt", mirnacol="miRNA Name",
    assayidcol="ASSAYID", groupcol="GROUP", 
    filterflagcol="FILTERFLAG", expressioncol=NA, 
    foldchangecol=NA, pvaluecol=NA)
}
\arguments{
 \item{mirnafile}{
     The tab-delimited miRNA results file to be loaded. The file is expected to be in tall-skinny format.
 }
 \item{mirnacol}{
     The name of the column header which contains the miRNA names
     being assayed.
 }
 \item{assayidcol}{
     The name of the column containing values which distinguish
     different assays for the same miRNA.
 }
 \item{groupcol}{
     The (optional) name of the column which contains sample
     group information. Enrichment is run separately for each
     sample group, defining a unique universe for the basis of
     the enrichment.
 }
 \item{filterflagcol}{
     The column header which does or will contain a flag
     distinguishing hits from non-hits. This column is typically
     not supplied and is created during the 
     \code{filtermirnapath} step.
 }
 \item{expressioncol}{
     The (optional) column header for values containing the
     expression abundances of the miRNAs assayed.
 }
 \item{foldchangecol}{
     The (optional) column header for values containing the fold changes
     of the miRNAs assayed.
 }
 \item{pvaluecol}{
     The (pvaluecol) column header for values containing the
     P-values of the miRNAs assayed.
 }
}
\details{
This method is the primary means for loading data into the
miRNApath package.

Data is not assumed to have any particular numerical values,
however the basic column types are typically used: expression
abundance, fold change, and P-value. Should one or more columns
be specified and available, it will be available for filtering
later on with \code{\link{filtermirnapath}}.

The group column assumes there is one column containing all
sample group information.

The assayid column is used to distinguish multiple assays for the
same miRNA, such as different vendors, or even different
preparations of the same miRNA assay.
}
\value{
The method returns an object of type mirnapath, a list with
components:

  \item{ mirnaTable }{
      data.frame containing the miRNA results data
  }
  \item{ columns }{
      list containing the names of required column headers
      associated to the actual column header supplied in the
      dataset contained in mirnaTable. Required headers:
      mirnacol, assayidcol. Optional headers: groupcol,
      pvaluecol, foldchangecol, expressioncol,
      filterflagcol
  }
  \item{ groupcount }{
      the number of groups contained in mirnaTable using the
      groupcol, if supplied
  }
  \item{ state }{
      the current state of the object, using the following
      values in order of progress through the typical workflow:
      unfiltered, filtered, enriched.
  }
}
\references{
    John Cogswell (2008) Identification of miRNA changes
    in Alzheimer's disease brain and CSF yields putative 
    biomarkers and insights into disease pathways, Journal of
    Alzheimer's Disease 14, 27-41.
}
\author{ James M. Ward \email{jmw86069@gmail.com} }
\seealso{
    \code{\link{loadmirnapath}},
    \code{\link{filtermirnapath}},
    \code{\link{loadmirnatogene}},
    \code{\link{loadmirnapathways}}
}
\examples{

## Start with miRNA data from this package
data(mirnaobj);

## Write a file as example of required input
write.table(mirnaobj@mirnaTable, file = "mirnaobj.txt", 
    quote = FALSE, row.names = FALSE, col.names = TRUE, na = "",
    sep = "\t");

## Now essentially load it back, but assign column headers
mirnaobj <- loadmirnapath( mirnafile = "mirnaobj.txt",
    pvaluecol = "P-value", groupcol = "GROUP", 
    mirnacol = "miRNA Name", assayidcol = "ASSAYID" );

## Display summary information for the resulting object
mirnaobj;
}

\keyword{ IO }
\keyword{ manip }

\name{checkColumns}
\alias{checkColumns}
\title{ Check data.frame for Required Columns }
\description{
  Internal function designed to assist checking for required
  columns in a data.frame.
}
\usage{
checkColumns(data, mandatory=NA, numeric=NA)
}
\arguments{
  \item{data}{ data.frame }
  \item{mandatory}{ list of required columns }
  \item{numeric}{ list of columns expected to be numeric }
}
\value{
  boolean, or stop() with columns not meeting the criteria
}
\author{ James M. Ward \email{jmw86069@gmail.com} }
\examples{
## No examples currently
}

\keyword{ manip }
\keyword{ internal }

\name{filtermirnapath}
\alias{filtermirnapath}
\title{ Filter miRNApath data }
\description{
    This method filters the miRNApath data to denote hits versus
    non-hits, the required distinction for running the enrichment
    algorithm. Data is expected to have been loaded by the
    \code{loadmirnapath} method.
}
\usage{
filtermirnapath(mirnaobj, pvalue=NA, expression=NA, foldchange=NA)
}
\arguments{
 \item{mirnaobj}{
    An object of type mirnapath containing data resulting from
    the \code{loadmirnapath} method.
 }
 \item{pvalue}{
    If a p-value column has been defined in the mirnapath object,
    this value is used to define a subset of entries within the
    dataset which will be denoted as hits.
 }
 \item{expression}{
    If an expression column has been defined in the mirnapath
    object, this value will be used to define entries with
    expression above this expression level as hits.
 }
 \item{foldchange}{
    If a fold change column has been defined in the mirnapath
    object, this value is used to require hits to have a fold
    change greater than or equal to this value. The fold change
    is evaluated in both the positive and the negative, such
    that a foldchange=2 will allow foldchange=2 and
    foldchange=-2.
 }
}
\details{
    This method takes a mirnapath object and assigns a flag for
    hits and non-hits, depending upon what filter criteria was
    provided. If multiple criteria are provided, they will all be
    collectively applied such that all criteria must be
    fulfilled. To that end, multiple calls to this function
    on the same mirnapath object should successively shrink the
    list of hits dependent upon the given criteria.
}
\value{
  Object of type mirnapath. The state of the object will reflect
  that the data has been filtered.
}
\references{
    John Cogswell (2008) Identification of miRNA changes
    in Alzheimer's disease brain and CSF yields putative 
    biomarkers and insights into disease pathways, Journal of
    Alzheimer's Disease 14, 27-41.
}
\author{ James M. Ward \email{jmw86069@gmail.com} }
\note{
    The method attempts to convert fold change columns
    appropriately so that filtering by 2 will properly mark
    entries greater than 2, less than -2, or less than 0.5,
    as the case may be.
}
\seealso{
    \code{\link{loadmirnapath}},
    \code{\link{filtermirnapath}},
    \code{\link{loadmirnatogene}},
    \code{\link{loadmirnapathways}}
}
\examples{

## Load miRNA expression data from AD miRNA paper
## This data contains miRNA expression data, 
data(mirnaobj);

## Display the state, which should generally be "unfiltered"
## at this point
mirnaobj@state;

## Display summary information about the object
mirnaobj;

## Annotate hits by filtering by P-value 0.05
mirnaobj <- filtermirnapath( mirnaobj, pvalue = 0.05,
    expression = NA, foldchange = NA );

## Display summary, noting the state is "filtered"
mirnaobj;
}

\keyword{ manip }

\name{loadmirnapathways}
\alias{loadmirnapathways}
\title{Load gene to pathway associations for miRNApath}
\description{
 This method loads associations between genes and the pathways to which they belong.
}
\usage{
loadmirnapathways(mirnaobj, pathwayfile, genecol="Entrez Gene ID",
pathwaycol="PATHWAY", columns=c(), pathwayidcol=NA)
}
\arguments{
 \item{mirnaobj}{
     An object of type mirnapath containing data resulting from
     the \code{loadmirnapath} method.
 }
 \item{pathwayfile}{
     The file containing the gene to pathway associations.
 }
 \item{genecol}{
     The name of the column header which contains the gene names
     associated with pathway data.
 }
 \item{pathwaycol}{
     The name of the column header which contains the pathway
     names.
 }
 \item{columns}{
     The names of any additional columns in the file being read
     which should equate with the mirnapath object.
 }
 \item{pathwayidcol}{
     The (optional) column header for IDs associated with the
     pathway names.
 }
}
\details{
  The data loaded is expected to have gene names which exactly
  match those gene names loaded by \code{loadmirnatogene}.
}
\value{
The method returns an object of type mirnapath, a list with
components:

  \item{ mirnaTable }{
      data.frame containing the miRNA results data
  }
  \item{ columns }{
      list containing the names of required column headers
      associated to the actual column header supplied in the
      dataset contained in mirnaTable. Required headers:
      mirnacol, assayidcol. Optional headers: groupcol,
      pvaluecol, foldchangecol, expressioncol,
      filterflagcol
  }
  \item{ groupcount }{
      the number of groups contained in mirnaTable using the
      groupcol, if supplied
  }
  \item{ state }{
      the current state of the object, using the following
      values in order of progress through the typical workflow:
      unfiltered, filtered, enriched.
  }
}
\references{
    John Cogswell (2008) Identification of miRNA changes
    in Alzheimer's disease brain and CSF yields putative 
    biomarkers and insights into disease pathways, Journal of
    Alzheimer's Disease 14, 27-41.
}
\author{ James M. Ward \email{jmw86069@gmail.com} }
\seealso{
    \code{\link{loadmirnapath}},
    \code{\link{filtermirnapath}},
    \code{\link{loadmirnatogene}},
    \code{\link{loadmirnapathways}},
    \code{\link{runEnrichment}}
}
\examples{

## Load miRNA expression data from AD miRNA paper
## This data contains miRNA expression data, 
data(mirnaobj);

## Write a file as example of required input
write.table(mirnaobj@mirnaPathways, file = "mirnaPathways.txt", 
    quote = FALSE, row.names = FALSE, col.names = TRUE, na = "",
    sep = "\t");

## Load the gene to pathway associations
mirnaobj <- loadmirnapathways( mirnaobj = mirnaobj, 
    pathwayfile = "mirnaPathways.txt", 
    pathwaycol = "Pathway Name", genecol = "Entrez Gene ID");

## Display summary, noting the number of genes reported
mirnaobj;
}

\keyword{ IO }
\keyword{ manip }
\keyword{ attribute }

\name{mirnaobj}
\alias{mirnaobj}
\docType{data}
\title{ mirnaobj, an S4 object of class "mirnapath" }
\description{
  An example miRNApath data object containing miRNA data, gene 
  and pathway associations. The object represents the end result
  of the miRNApath workflow, and serves a convenient source for
  example data.
}
\usage{data(mirnaobj)}
\format{
  The format is an S4 class \code{"mirnapath"} with
   \code{slotNames} as follows:

  \describe{\item{ \code{mirnaTable} }{
      data.frame containing the miRNA results data, expected to
      contain columns with miRNA name, gene name, and ideally
      some column(s) for filtering hits versus background, e.g.
      fold change, expression abundance, P-value. Once the data
      is filtered (see state below) there will be a column with
      a flag indicating which entries are hits and which are
      considered background. This column is found in 
      \code{mirnaobj@columns["filterflagcolumn"]} and is typically
      \code{"FILTERFLAG"}.
  }
  \item{ \code{columns} }{
      Named list of column headers used throughout the analysis.
      The purpose of the names is partly to retain the original
      headers in the mirnaTable data.frame, and partly to
      coordinate the names with the miRNA-gene and gene-pathway
      tables used later in the analysis. The recognized headers:
      \code{mirnacol, assayidcol, genecol, pvaluecol, foldchangecol,
      pathwaycol, pathwayidcol, groupcol, mirnagene}. See the
      documentation for the mirnapath object type for more
      details about usage.
  }
  \item{ \code{groupcount} }{
      Numerical value indicating how many sample groups are
      available in the data, provided for convenience.
  }
  \item{ \code{state} }{
      Character value indicating the current analysis state,
      with values: \code{"unfiltered"} if results are loaded but not
      yet filtered; \code{"filtered"} if results are loaded and hits
      are defined with the filterflagcol column; \code{"enriched"} if
      the data is loaded, filtered, and analyzed for enrichment.
      One can load mirna-gene and gene-pathway data at any point
      which necessitates using the \code{mirnaobj@mirnaGene} or
      \code{mirnaobj@mirnaPathways} object elements to determine if
      that data has been loaded.
  }
  \item{ \code{mirnaGene} }{
      data.frame containing associations between miRNA and
      genes. The data should contain one miRNA-to-gene
      relationship per row, and should contain only those two
      columns. Additional columns are maintained but ignored.
      Note that one can use any values in the genecol column,
      provided they match exactly with values found in the
      \code{mirnaobj@mirnaPathways} element (see below.) Therefore,
      if desired one can use transcript or gene associations,
      or other integration methods as desired.
  }
  \item{ \code{mirnaPathways} }{
      data.frame containing gene-pathway associations. The data
      should contain only one gene-to-pathway association per
      row of data. The data can have pathway ID values, which
      may facilitate comparisons to pathway databases (and may
      allow substantial data volume reduction if necessary.) If
      there is no pathwayidcol column, then one will be created
      using a numerical assignments of the pathway names. Note
      that this conversion is not sensitive to pathway sources,
      so care should be taken to include pathway source in the
      pathway name if two sources share the same pathway name.
      The same is true for pathway ID values, should they be
      purely numerical and have shared values across pathway
      sources.
  }
  \item{ \code{pathwaycount} }{
      Numerical value indicating how many pathways are
      available in the data, provided for convenience.
  }
  \item{ \code{filters} }{
      List of filters applied to the data, which may include:
      \code{"P-value", "Fold change"}, and/or \code{"Expression"}.
  }
  \item{ \code{enrichment} }{
      Enrichment summary data in the form of a list of elements
      for each sample group (the sample group is the name of
      each element.) Each list element is itself a list with
      enrichment result data for each sample group, as
      independently calculated: \code{"pvalues"} - list of P-values
      named by pathway ID; \code{"Measured pathway mirnaGenes"} -
      total number of miRNA-gene-pathway combinations measured,
      which gives some idea of the overall coverage of pathways.
      The general point is that miRNAs have the potential to
      cover many genes and pathways; \code{"Total mirnaGenes"} - number
      of miRNA-gene combinations represented in the data;
      \code{"Enriched pathway mirnaGenes"} - number of miRNA-gene values
      enriched in the pathway tested; \code{"Enriched by miRNA"} - list
      of miRNAs involved in the pathway tested, with the list of
      genes in parentheses per miRNA; \code{"Enriched by Gene"} - same
      as previous except switching gene and miRNA; \code{"Total
      enriched mirnaGenes"} - the total number of miRNA-gene
      values involved in any pathway enrichment (significant or
      not.) The total values are useful when comparing across
      sample groups, looking particularly for groups with few
      changes or those with a uniquely high number of changes.
  }
  \item{ \code{pathwayList} }{
      Named list of pathways contained in the
      \code{mirnaobj@mirnaPathways} object, named by the pathway ID
      values found in the pathwayidcol column. This list
      facilitates converting the data in the enrichment element
      to pathway names, since those values are named by the
      pathway ID to conserve memory.
  }}

}
\source{
  Journal of Alzheimers Disease 14, 27-41.
}
\references{
    John Cogswell (2008) Identification of miRNA changes
    in Alzheimer's disease brain and CSF yields putative 
    biomarkers and insights into disease pathways, Journal of
    Alzheimer's Disease 14, 27-41.
}
\examples{
## Load the data
data(mirnaobj)

## Print the default summary
mirnaobj;
}
\keyword{datasets}

\name{miRNApath-package}
\alias{miRNApath-package}
\docType{package}
\title{
miRNApath: Pathway Enrichment for miRNA Expression Data

}
\description{
This package provides methods for assessing the statistical 
over-representation of miRNA effects on gene sets, using
supplied miRNA-to-gene associations. Because these associations
are notably many-to-many (one miRNA to many genes; one gene
affected by many miRNAs) the assessment is complex and warrants
perhaps different approaches than are classically performed on
differential gene expression datasets.
}
\details{
\tabular{ll}{
Package: \tab miRNApath\cr
Type: \tab Package\cr
Version: \tab 1.0\cr
Date: \tab 2008-04-02\cr
License: \tab LGL-2.1, see COPYING.LIB\cr
}
}
\author{
James M. Ward

Maintainer: James M. Ward <jmw86069@gmail.com>

}
\references{
    John Cogswell (2008) Identification of miRNA changes
    in Alzheimer's disease brain and CSF yields putative 
    biomarkers and insights into disease pathways, Journal of
    Alzheimer's Disease 14, 27-41.
}
\keyword{ package }
\keyword{ htest }
\seealso{
    \code{\link{loadmirnapath}},
    \code{\link{filtermirnapath}},
    \code{\link{loadmirnatogene}},
    \code{\link{loadmirnapathways}},
    \code{\link{runEnrichment}}
}
\examples{
\dontrun{
## Start with miRNA data from this package
data(mirnaobj);

## Write a file as example of required input
write.table(mirnaobj@mirnaTable, file = "mirnaTable.txt", 
    quote = FALSE, row.names = FALSE, col.names = TRUE, na = "",
    sep = "\t");

## Now essentially load it back, but assign column headers
mirnaobj <- loadmirnapath( mirnafile = "mirnaTable.txt",
    pvaluecol = "P-value", groupcol = "GROUP", 
    mirnacol = "miRNA Name", assayidcol = "ASSAYID" );

## Start with miRNA data from this package
data(mirnaobj);

## Write a file as example of required input
write.table(mirnaobj@mirnaGene, file = "mirnaGene.txt", 
    quote = FALSE, row.names = FALSE, col.names = TRUE, na = "",
    sep = "\t");

## Load the miRNA to gene associations
mirnaobj <- loadmirnatogene( mirnafile = "mirnaGene.txt",
    mirnaobj = mirnaobj, mirnacol = "miRNA Name",
    genecol = "Entrez Gene ID", 
    columns = c(assayidcol = "ASSAYID") );

## Write a file as example of required input
write.table(mirnaobj@mirnaPathways, file = "mirnaPathways.txt", 
    quote = FALSE, row.names = FALSE, col.names = TRUE, na = "",
    sep = "\t");

## Load the gene to pathway associations
mirnaobj <- loadmirnapathways( mirnaobj = mirnaobj, 
    pathwayfile = "mirnaPathways.txt", 
    pathwaycol = "Pathway Name", genecol = "Entrez Gene ID");

## Annotate hits by filtering by P-value 0.05
mirnaobj <- filtermirnapath( mirnaobj, pvalue = 0.05,
    expression = NA, foldchange = NA );

## Now run enrichment test
mirnaobj <- runEnrichment( mirnaobj=mirnaobj, Composite=TRUE,
   groups=NULL, permutations=0 );

## Print out a summary table of significant results
finaltable <- mirnaTable( mirnaobj, groups=NULL, format="Tall", 
    Significance=0.1, pvalueTypes=c("pvalues") );
finaltable[1:4,];

## Example which calls heatmap function on the resulting data
widetable <- mirnaTable( mirnaobj, groups=NULL, format="Wide", 
    Significance=0.1, na.char=NA, pvalueTypes=c("pvalues") );
## Assign 1 to NA values, assuming they're all equally
## non-significant
widetable[is.na(widetable)] <- 1;

## Display a heatmap of the result across sample groups
pathwaycol <- mirnaobj@columns["pathwaycol"];
pathwayidcol <- mirnaobj@columns["pathwayidcol"];
rownames(widetable) <- apply(widetable[,c(pathwaycol,
   pathwayidcol)], 1, function(i)paste(i, collapse="-"));
wt <- as.matrix(widetable[3:dim(widetable)[2]], mode="numeric")
heatmap(wt, scale="col");

## Show results where pathways are shared in four or more
## sample groups
pathwaySubset <- apply(wt, 1, function(i)
{
   length(i[i < 1]) >= 4;
} )
heatmap(wt[pathwaySubset,], scale="row");
}
}

\name{runEnrichment}
\alias{runEnrichment}
\title{ Perform gene set enrichment analysis on a miRNApath 
   object }
\description{
   This method performs a hypergeometric enrichment analysis on
   a miRNApath object, which should already contain miRNA data,
   miRNA-gene associations, gene-pathway associations, and some
   criteria for filtering miRNA hits from the full tested set.
}
\usage{
runEnrichment(mirnaobj, Composite=TRUE, groups=NULL,
permutations=0)
}
\arguments{
 \item{mirnaobj}{
     An object of type mirnapath containing data resulting from
     the \code{loadmirnapath} method.
 }
 \item{Composite}{
     Defines whether the enrichment treats miRNA-gene as the
     enriched entity, or uses only the gene.
 }
 \item{groups}{
     List of groups to include in the analysis, although each
     group is analyzed independent from the other groups.
 }
 \item{permutations}{
     The number of permutations to use in calculating an adusted
     P-value. Value of 0 will perform no permutations.
 }
}
\details{
  The composite flag indicates whether to treat the fully 
  expanded miRNA-gene combinations as separate enrichment events
  (TRUE), or whether to treat all effects on one gene as one
  collective event. The latter case reverts to the classic
  un-ordered hypergeometric enrichment technique.

  However the expansion of combinations is the current method
  chosen to represent the multiple predicted effects of miRNAs
  to one gene, and the predicted effect of one miRNA to multiple
  genes. The algorithm will identify statistically significantly
  enriched results when the combination of these effects is
  greater than would be anticipated by random chance.

  The adjusted P-value is calculated using the rank of
  unadjusted P-values divided by the number of permutations
  minus one (such that the best rank from 1,000 permutations
  yields an adjusted P-value of 0.001.) The default value 0 was
  put in place to save time, since most adjustments resulted in
  stronger "hits" and weaker "non-hits" in terms of pathways
  enriched. Thus the results are not substantially changed, and
  permutation adjustment is saved for the final result set.
}
\value{
The method returns an object of type mirnapath, a list with
components:

  \item{ mirnaTable }{
      data.frame containing the miRNA results data
  }
  \item{ columns }{
      list containing the names of required column headers
      associated to the actual column header supplied in the
      dataset contained in mirnaTable. Required headers:
      mirnacol, assayidcol, groupcol, filterflagcol.
  }
  \item{ groupcount }{
      The number of groups contained in mirnaTable using the
      groupcol, if supplied
  }
  \item{ state }{
      The current state of the object, in this case "enriched".
  }
  \item{ mirnaGene }{
      data.frame containing associations between miRNAs and
      genes.
  }
  \item{ mirnaPathways }{
      data.frame containing gene-pathway associations.
  }
  \item{ pathwaycount }{
      Numerical value indicating how many pathways are
      available in the data, provided for convenience.
  }
  \item{ filters }{
      List of filters applied to the data, which may include:
      "P-value", "Fold change", and/or "Expression".
  }
  \item{ enrichment }{
      Enrichment summary data in the form of a list of elements
      for each sample group (the sample group is the name of
      each element.) Each list element is itself a list with
      enrichment result data for each sample group, as
      independently calculated: "pvalues" - list of P-values
      named by pathway ID. "Measured pathway mirnaGenes" -
      total number of miRNA-gene-pathway combinations measured,
      which gives some idea of the overall coverage of pathways.
      The general point is that miRNAs have the potential to
      cover many genes and pathways. "Total mirnaGenes" - number
      of miRNA-gene combinations represented in the data.
      "Enriched pathway mirnaGenes" - number of miRNA-gene values
      enriched in the pathway tested. "Enriched by miRNA" - list
      of miRNAs involved in the pathway tested, with the list of
      genes in parentheses per miRNA. "Enriched by Gene" - same
      as previous except switching gene and miRNA. "Total
      enriched mirnaGenes" - the total number of miRNA-gene
      values involved in any pathway enrichment (significant or
      not.) The total values are useful when comparing across
      sample groups, looking particularly for groups with few
      changes or those with a uniquely high number of changes.
      Lastly, with permutations > 0 "Permutation P-value" will
      contain the rank-adjusted P-value as described in the
      details section.
  }
  \item{ pathwayList }{
      Named list of pathways contained in the
      mirnaobj\$mirnaPathways object, named by the pathway ID
      values found in the pathwayidcol column. This list
      facilitates converting the data in the enrichment element
      to pathway names, since those values are named by the
      pathway ID to conserve memory.
  }
}
\references{
    John Cogswell (2008) Identification of miRNA changes
    in Alzheimer's disease brain and CSF yields putative 
    biomarkers and insights into disease pathways, Journal of
    Alzheimer's Disease 14, 27-41.
}
\author{ James M. Ward \email{jmw86069@gmail.com} }
\seealso{
    \code{\link{loadmirnapath}},
    \code{\link{filtermirnapath}},
    \code{\link{loadmirnatogene}},
    \code{\link{loadmirnapathways}}
}
\examples{
\dontrun{
## Start with miRNA data from this package
data(mirnaobj);

## Now run enrichment test
mirnaobj <- runEnrichment( mirnaobj=mirnaobj, Composite=TRUE,
   groups=NULL, permutations=0 );
}
}

\keyword{ htest }
